﻿#encoding: UTF-8

from PIL import ImageDraw, ImageFont, Image
from scripts import led_util as util

class led_111a20(abstractscreenrenderer):
	def __init__(self, lookup_path):
		# kolory
		self.kolor_tlo = (12, 12, 12)
		self.kolor = (146, 72, 15)
		# wczytujemy fonty
		self.font = util.load_font("tab_wag_111a_20")
		self.font2 = util.load_font("tab_wag_111a_20_num")
		# ikonka wagonika
		self.wag = util.load_spr("symb_wag/111a_20")

	def _render(self, state):

		# state puste = tablica pusta
		if "dummy" in state:
			img = util.render_post(self.render_tab(None))
			return img.resize((512,256), Image.ANTIALIAS)

		kod_E = state['kod_e']
		kod_P = state['kod_p']
		kod_O = state['kod_o']

		nrpoc = ' '
		# wyluskaj numer pociagu
		if ((state['trainnumber'] == 'none') or (state['trainnumber'] == 'rozklad') ):
			nrpoc = ' '
		else:
			nrpoc = trainNumber(state['trainnumber'])
			pelny_nrpoc = state['trainnumber']
			if pelny_nrpoc[0] == "E":
				nrpoc = kod_E.upper() + " " + nrpoc
			elif pelny_nrpoc[1] == "P" and pelny_nrpoc[0] <> "A":
				nrpoc = kod_P.upper() + " " + nrpoc
			else:
				nrpoc = kod_O.upper() + " " + nrpoc

		#klon z SRG - odczytywanie stacji z postojami
		numeraktualnejstacji = 0
		numerostatniejstacji = 0
		nazwa_st_koncowej = ""
			
		stacje = []
		teraz = False

		if state["train_stationcount"]>0:
			if state["train_station1_name"] <> state["train_stationfrom"]:
				stacje.append(removeUnderscores(state["train_stationfrom"]))
		
		for i in range(state["train_stationcount"]):
			if i + 1 == state["train_stationindex"]:
				teraz = True
			if state["train_station" + str(i + 1) + "_ah"] != -1:
				stacje.append(removeUnderscores(state["train_station" + str(i + 1) + "_name"]))
				if teraz:
					numeraktualnejstacji = len(stacje)-1 # stacje na sterowniku numerowane sa od 0
					teraz = False
			
		if state["train_stationcount"] > 0:
			if stacje[-1] <> state["train_stationto"]:
				stacje.append(removeUnderscores(state["train_stationto"]))
			numerostatniejstacji = len(stacje)-1
			nr_st_koncowej = len(stacje)-1
			nazwa_st_koncowej = stacje[-1]



		# gdy sa stacje to dzialaj z bokiem
		data = None
		
		if numerostatniejstacji > 0:

			nazwa_st_pocz = stacje[0]

			msg_przez = ''
			for i in range(numerostatniejstacji - numeraktualnejstacji - 1):
				if i > 0:
					msg_przez += " - "
				msg_przez += stacje[numeraktualnejstacji + i + 1]
			
			data = {
				"station1":nazwa_st_pocz,
				"station2":nazwa_st_koncowej,
				"stations":msg_przez,
				"trainnumber":nrpoc,
				"trainname":"", # todo
				"wagonnumber":"" # todo
			}
			
		img = util.render_post(self.render_tab(data))		

		return img.resize((512,256), Image.ANTIALIAS)



	def render_tab(self, data):
		
		img = Image.new("RGB", (144, 64), self.kolor_tlo)
		
		# nic nie rysujemy jesli nie ma danych (ekran wygaszony)
		if data == None:
			return img
		
		# w przeciwnym razie lecimy dalej
		px = img.load()
		
		# tekst
		util.draw_str(px, 0, 0, img.size[0], img.size[1], data["trainnumber"], self.font, self.kolor)
		util.draw_str(px, 144 - util.get_str_len(data["trainname"], self.font), 0, img.size[0], img.size[1], data["trainname"], self.font, self.kolor)
		util.draw_str(px, 0, 16, img.size[0], img.size[1], data["station1"], self.font, self.kolor)
		util.draw_str(px, 0, 32, img.size[0], img.size[1], data["stations"], self.font, self.kolor) # powinno byc przewijane
		util.draw_str(px, 113 - util.get_str_len(data["station2"], self.font), 48, img.size[0], img.size[1], data["station2"], self.font, self.kolor)
		
		# ucinamy nadmiarowy tekst przy przesuwanej liscie stacji
		for i in range(31):
			for j in range(48):
				px[113 + i, j + 16] = self.kolor_tlo
		
		# numer wagonu
		util.draw_str(px, 122, 41, img.size[0], img.size[1], data["wagonnumber"], self.font2, self.kolor)
		# wagonik
		util.draw_spr(px, 120, 23, img.size[0], img.size[1], self.wag, self.kolor)
		
		# ramki
		for i in range(144): # pozioma
			px[i, 15] = self.kolor
		for i in range(48): # pionowa
			px[115, 16 + i] = self.kolor
		
		return img
		


def removeUnderscores(string):
	return string.replace("_", " ")

def trainNumber(trainName):
	digits = ("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	for i in range(len(trainName)):
		if trainName[i:(i + 1)] in digits:
			return trainName[i:]
